题目链接:http://codeforces.com/contest/1102/problem/E
题意是给了n个数的a数组,要构造b数组,b数组需要满足以下三个要求,b[1] = 0,如果a[i] = a[j],那么b[i] = b[j](a中相等的数,在b中对应的位置的数也相等),b[i] = b[i+1]或者b[i] + 1 = b[i+1],求出可以构造出多少种b数组。
【Codeforces Round #531 (Div. 3) E. Monotonic Renumeration(思维+差分数组)】首先我们要知道假如a[1] = 15,a[20] = 15,因为b[1] = 0,所以b[20] = 0,又因为b数组是一个递增的数列,所以在b数组中从1到20就一定都是0,所以我们就只需要去找区间,因为b[i+1]要么等于b[i]要么等于b[i]+1,所以如果我们找到了一个区间的左端点与之前的所有区间都没有交集,那么此时的方案数是乘以2的,所以这道题就是找有多少个独立的区间,每一个独立的区间的方案数就是2。我的方法是用差分数组来实现区间覆盖,对于每一个数用map来做标记。
AC代码:
#include
#define maxn 200005
#define ll long long
const int mod = 998244353;
using namespace std;
int n;
ll pre[maxn];
int main()
{
map ma;
scanf("%d",&n);
for(int i=1;
i<=n;
i++){
ll xx;
scanf("%lld",&xx);
if(ma[xx] == 0) ma[xx] = i;
else pre[ma[xx] + 1] ++, pre[i + 1] --;
}
ll ans = 1;
for(int i=2;
i<=n;
i++){
pre[i] += pre[i-1];
if(pre[i] == 0) ans = (ans * 2 + mod) % mod;
}
printf("%lld\n", ans);
return 0;
}
推荐阅读
- codeforces B. Young Explorers
- codeforces C. Mere Array
- codeforces D. Omkar and Bed Wars
- codeforces C. Omkar and Waterslide
- codeforces B. Omkar and Infinity Clock
- codeforces B. Ternary Sequence
- 题库-CF|【Codeforces Round 370 (Div 2) E】【线段树 等比数列 区间合并】Memory and Casinos 赌场区间[l,r] l进r先出的概率
- 题库-CF|【Codeforces Round 263 (Div 2)C】【贪心 哈弗曼思维】Appleman and Toastman 每个非1size子树延展为2子树的最大权
- Codeforces|Codeforces Round #605 (Div. 3) D. Remove One Element
- Codeforces|Codeforces Round #643 (Div. 2) B.Young Explorers